/***************************  Datum.java  *************************************/

import AlgoTools.IO;

/** Klasse Datum 
 *  bestehend aus drei Integers (Tag, Monat, Jahr) 
 *  mit zwei Konstruktoren zum Anlegen eines Datums
 *  und einer Methode zur Umwandlung eines Datums in einen String
 */

public class Datum {

  int tag;                                     // Datenfeld tag 
  int monat;                                   // Datenfeld monat 
  int jahr;                                    // Datenfeld jahr

  public Datum (int tag, int monat, int jahr){ // Konstruktor mit 3 Parametern
    this.tag   = tag;                          // initialisiere Tag 
    this.monat = monat;                        // initialisiere Monat
    this.jahr  = jahr;                         // initialisiere Jahr
  }

  public Datum (int jahr){                     // Konstruktor mit 1 Parameter
    this(1, 1, jahr);                          // initialisiere 1.1. Jahr
  }

  public String toString(){                    // Methode ohne Parameter
    return(tag+"."+monat+"."+jahr);            // liefert Datum als String
  }

  public static void main (String argv[]) {
 
    Datum d;                                   // deklariere ein Datum

    d = new Datum (15,8,1972);                 // kreiere Datum 15.08.1972 
    d = new Datum (1972);                      // kreiere Datum 01.01.1972 
    d.jahr++;                                  // erhoehe Datum um ein Jahr
    IO.println(d.toString());                  // drucke Datum
    IO.println(d);                             // hier: implizites toString()
  }
}
