/******************************  PraefixBaumBau.java  *************************/

import AlgoTools.IO;

/** Klasse PraefixBaumBau enthaelt statische Methode praefixBaumBau, 
 *  die einen Praefix-Ausdruck uebergeben bekommt 
 *  und den zugehoerigen Baum zurueckliefert.
 */

public class PraefixBaumBau {

  private static boolean is_operator(char c) {    // liefert true, 
    return (c=='+' || c=='-' || c=='*' || c=='/');// falls c ein Operator ist
  } 

  static int i=0;                                 // Laufindex

  public static Baum praefixBaumBau (char[] ausdruck) { 

    Baum links, rechts;                           // Hilfsbaeume
    char c;                                       // aktuelles Zeichen
        
    c = ausdruck[i++];                            // aktuelles Zeichen
        
    if (!is_operator(c))                          // falls Operand,
        return new Baum(new Character(c));        // liefere Operand als Baum 
    else {                                        // falls Operator,
        links  = praefixBaumBau(ausdruck);        // baue linken Sohn;
        rechts = praefixBaumBau(ausdruck);        // baue rechten Sohn 
        return (new Baum(links,new Character(c),rechts)); // verbinde 
    }
  }

  public static void main (String argv[]) {
    char [] zeile = IO.readChars("Bitte Praefix-Ausdruck: ");  // lies Praefix
    Baum wurzel = praefixBaumBau(zeile);          // konstruiere daraus Baum
    IO.print("Inorder lautet:         ");         // kuendige Traversierung an 
    Traverse.klammerinorder(wurzel);              // gib in Klammer-Inorder aus
    IO.println();
  }
}
