/*****************************  TraverseTest.java  ****************************/
                                                         //         '/'
import AlgoTools.IO;                                     //      /       \
                                                         //      +       -
/** Traversierungen des binaeren Baums mit Operanden in  //    /   \   /   \
 *  den Blaettern und Operatoren in den inneren Knoten:  //    F   *   X   Y
 */                                                      //       / \
                                                         //       A B
public class TraverseTest {

    public static void main(String[] argv) {

        Baum a     = new Baum(new Character('A'));
        Baum b     = new Baum(new Character('B'));
        Baum mal   = new Baum(a, new Character('*'), b);
        Baum f     = new Baum(new Character('F'));
        Baum plus  = new Baum(f, new Character('+'), mal);
        Baum x     = new Baum(new Character('X'));
        Baum y     = new Baum(new Character('Y'));
        Baum minus = new Baum(x, new Character('-'), y);
        Baum durch = new Baum(plus, new Character('/'), minus);

        IO.print("Preorder:        ");
        Traverse.preorder(durch);         // Ausgabe: /+F*AB-XY
        IO.println();

        IO.print("Inorder:         ");
        Traverse.inorder(durch);          // Ausgabe: F+A*B/X-Y
        IO.println();

        IO.print("Postorder:       ");
        Traverse.postorder(durch);        // Ausgabe: FAB*+XY-/
        IO.println();

        IO.print("Klammer-Inorder: ");
        Traverse.klammerinorder(durch);   // Ausgabe: ((F+(A*B))/(X-Y))
        IO.println();

        IO.print("Tiefensuche:     ");
        TiefenSuche.tiefenSuche(durch);   // Ausgabe: /+F*AB-XY
        IO.println();

        IO.print("Breitensuche:    ");
        BreitenSuche.breitenSuche(durch); // Ausgabe: /+-F*XYAB
        IO.println();
    }
}
